org.apache.solr.client.solrj.io

## Class ParallelStream

- java.lang.Object
- - org.apache.solr.client.solrj.io.TupleStream
  - - org.apache.solr.client.solrj.io.CloudSolrStream
    - - org.apache.solr.client.solrj.io.ParallelStream

All Implemented Interfaces:
  Serializable

    public class ParallelStream
    extends CloudSolrStream

The ParallelStream decorates a TupleStream implementation and pushes it to N workers for parallel execution. Workers are chosen from a SolrCloud collection. Tuples that are streamed back from the workers are ordered by a Comparator.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.solr.client.solrj.io.CloudSolrStream

`CloudSolrStream.StreamOpener, CloudSolrStream.TupleWrapper`

### Field Summary

### Fields inherited from class org.apache.solr.client.solrj.io.CloudSolrStream

`cache, cloudSolrClient, collection, comp, eofTuples, params, solrStreams, streamContext, tuples, zkHost`

### Constructor Summary

Constructors
Constructor and Description
`ParallelStream(String zkHost, String collection, TupleStream tupleStream, int workers, Comparator<Tuple> comp)`

### Method Summary

Methods
`List<TupleStream>` `children()`
`protected void` `constructStreams()`
`Tuple` `read()`
`void` `setStreamContext(StreamContext streamContext)`

### Methods inherited from class org.apache.solr.client.solrj.io.CloudSolrStream

`_read, close, getEofTuples, open, setComp, setFieldMappings, setTrace`

### Methods inherited from class org.apache.solr.client.solrj.io.TupleStream

`getCost`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ParallelStream

    public ParallelStream(String zkHost,
                  String collection,
                  TupleStream tupleStream,
                  int workers,
                  Comparator<Tuple> comp)
                   throws IOException

Throws:
  `IOException`

### Method Detail

#### children

    public List<TupleStream> children()

Overrides:
  `children` in class `CloudSolrStream`

#### read

    public Tuple read()
               throws IOException

Overrides:
  `read` in class `CloudSolrStream`
Throws:
  `IOException`

#### setStreamContext

    public void setStreamContext(StreamContext streamContext)

Overrides:
  `setStreamContext` in class `CloudSolrStream`

#### constructStreams

    protected void constructStreams()
                             throws IOException

Overrides:
  `constructStreams` in class `CloudSolrStream`
Throws:
  `IOException`